package require Iwidgets 3.0

wm title . "Install SMM++"

option add *textBackground seashell
#. configure -background white

proc helptext {a} {

    set ht ""
    switch $a {
	itkwish {
	    append ht "Enter here the itkwish command.\n"
	    append ht "You must give the _absolute_ path.\n"
	    append ht "/usr/bin or /usr/local/... may be good guesses.\n"
	    append ht "If you have the 'which' command installed, type:\n\n"
	    append ht "which <itkwish command>\n\n"
	    append ht "at the command prompt/shell prompt.\n"
	    append ht "<itkwish command> is mostlikely 'itkwish',\n"
	    append ht "maybe it is something like 'itkwish3.0' (extended by the version number)."
	}	
	userdir {
	    append ht "Here you give in the directory, where the\n"
	    append ht "user data is going to be installed"
	}
    }
    .help clear
    .help insert 0.0 $ht

}

set itkwish "/usr/local/bin/itkwish"
set userdir "\$env(HOME)/.smm"
set srcdir  "/usr/local/smm++"

iwidgets::entryfield .itkwish -labeltext "itkwish executable:" \
    -labelpos nw -textvariable itkwish \
    -command { focus [.userdir component entry] }
bind .itkwish <FocusIn> {helptext itkwish}

iwidgets::entryfield .userdir -labeltext "user directory" \
    -labelpos nw -textvariable userdir\
    -command { focus [.phone component entry] }
bind .userdir <FocusIn> {helptext userdir}

iwidgets::entryfield .smm -labeltext "SMM source dir.:" \
    -labelpos nw -textvariable srcdir \
    -command { focus [.itkwish component entry] }

iwidgets::scrolledtext .help -labeltext "Help:" -labelpos nw \
    -visibleitems 80x10

iwidgets::buttonbox .but -orient horizontal
.but add ok -text "Install SMM"
.but add no -text "Don't install" -command exit

pack .itkwish .userdir .smm .help .but \
    -fill both -expand 1


