class TSesManager {
    private common CSesList ;# is an array of objects

    private variable CFilM    ;# the file system manager
    private variable CMudM
    private variable CActSes

    constructor {aFileSystemManager aMudManager args} {
	set CFilM $aFileSystemManager
	set CMudM $aMudManager
	set CActSes ""

	# laod the session informations from files
	foreach sf [$CFilM getAllSesDataFiles] {
	    set ses [TSession ::\#auto $CFilM $sf]
	    set CSesList([$ses name]) $ses
	}
    }
    method sessionStarted {} { if {[string compare "" $CActSes]} { return 1 } else { return 0 } }
    method getSesNames {} { return [lsort [array names CSesList]] }
    method getMudNames {} { return [$CMudM getMudNames] }
    method getSes {aName} { return $CSesList($aName) } 
    method getSesId {aName} { return [$CSesList($aName) id]} 
    method exists {aName} { return [info exists CSesList($aName)] } 

    method add {aName aPlayer aPassword aMudName} {
	if {[exists $aName]} {
	    ::delete object $CSesList($aName)
	    unset CSesList($aName)	
	} 
	set id [getNewId]
	set CSesList($aName) [TSession ::\#auto $CFilM $aName $aPlayer $aPassword $aMudName $id]
    }
    method rem {aName} {
	if {[exists $aName]} {
	    $CSesList($aName) wipeout
	    ::delete object $CSesList($aName)
	    unset CSesList($aName)	
	}
    }
    method newActSes {aName} { set CActSes [getSes $aName] }
    method connectActSes {aMainWin aCon} { 
	$CActSes connect $CMudM $aMainWin $aCon
    }
    method sesDisconnected {} {
	# this will set CActSes etc,..
	# must be called from outside: main window
	set CActSes ""
    }
    method stopSession {} {
	if {[sessionStarted]} {
	    $CActSes disconnect
	}
    }
    method getSesIds {} { 
	set idlist [list]
	foreach name [getSesNames] {
	    lappend idlist [[getSes $name] id]
	}
	return $idlist
    }
    method getActSes {} { return $CActSes }
    method getActMudName {} { 
	if {[sessionStarted]} { 
	    return [$CActSes mudName]
	} else {
	    return ""
	}
    }
    method getActMud {} {
	return [$CMudM getMud [getActMudName]]
    }
    method getNewId {} {
	set id 0
	set idlist [getSesIds]
	while {[lsearch -exact $idlist $id]!= -1} {
	    incr id
	}
	return $id
    }

}
###################################################################################
class TSesManagerUif {
    inherit iwidgets::Shell

    variable CWid
    variable CWinWid
    variable CParent

    variable CSesM

    constructor {aParent aSesM args} {
	global TV
	set CSesM $aSesM

	configure -title "Session Manager"
	configure -modality application

	set CWid [$this childsite]
	regsub -- {^::} $this    {} CWinWid
	regsub -- {^::} $aParent {} CParent

	#########################################################################
	# create buttons
 	itk_component add   butframem {frame $CWid.butframe -relief ridge -bd 2 } {keep -background}
 	pack $itk_component(butframem) -side bottom -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0
 	itk_component add   butframe  {frame $itk_component(butframem).butframe -relief ridge -bd 0 } {keep -background}
 	pack $itk_component(butframe) -side bottom -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0
 	itk_component add   butframe2 {frame $itk_component(butframem).butframe2 -relief ridge -bd 0 } {keep -background}
 	pack $itk_component(butframe2) -side bottom -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0

 	itk_component add   ok {
 	    button $itk_component(butframe).ok -width 10 -text "save" -command "[code $this save]"
 	} {keep -background}
 	itk_component add   rem {
 	    button $itk_component(butframe).rem -width 10 -text "remove" -command "[code $this remove]"
 	} {keep -background}
 	itk_component add   canc {
 	    button $itk_component(butframe).canc -width 10 -text "close" -command "[code $this canc]"
 	} {keep -background}
 	pack $itk_component(ok) $itk_component(rem) $itk_component(canc) \
 	    -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left

 	itk_component add   start {
 	    button $itk_component(butframe2).start -width 10 -text "load" -command "[code $this startSes]"
 	} {keep -background}
 	itk_component add   connect {
 	    button $itk_component(butframe2).conn -width 10 -text "connect" -command "[code $this connect]"
 	} {keep -background}
 	itk_component add   stop {
 	    button $itk_component(butframe2).stop -width 10 -text "stop" -command "[code $this stop]"
 	} {keep -background}
 	pack $itk_component(stop) $itk_component(start) $itk_component(connect) \
 	    -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left

	#########################################################################
	# ses interface
 	itk_component add   mframe {frame $CWid.mframe -relief ridge -bd 2 } {keep -background}
 	pack $itk_component(mframe) -side top -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0

	######### name
	itk_component add   name {iwidgets::entryfield $itk_component(mframe).name -labeltext "name: " \
				      -width 20 -labelmargin 0 -textvariable TV($this,name)
	} {keep -background}
	itk_component add   player {iwidgets::entryfield $itk_component(mframe).player -labeltext "player: " \
				      -width 20 -labelmargin 0 -textvariable TV($this,player)
	} {keep -background}
	itk_component add   password {iwidgets::entryfield $itk_component(mframe).password -labeltext "password: " \
				      -width 20 -labelmargin 0 -textvariable TV($this,password)
	} {keep -background}
	itk_component add   mudname {
	    iwidgets::combobox $itk_component(mframe).mn \
		-popupcursor hand1 -listheight 100  \
		-labeltext "mud: " -editable 0 \
		-textvariable TV($this,mudname)
	} {keep -background}

	pack $itk_component(name) $itk_component(player) $itk_component(password) $itk_component(mudname) \
	    -side top -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0


	#########################################################################
	# Sessions selector
 	itk_component add   msframe {frame $CWid.msframe -relief ridge -bd 2 } {keep -background}
 	pack $itk_component(msframe) -side top -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0

	itk_component add   sesselector {
	    iwidgets::scrolledlistbox $itk_component(msframe).ms \
		-labeltext "Sessions: \n\n\n\n\n\n\n\n\n\n" -labelpos w \
		-selectioncommand "[code $this selected]" -height 1 
	} {keep -background}
 	pack $itk_component(sesselector) -side top -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0

	##########################################################################
	# align all that stuff
	iwidgets::Labeledwidget::alignlabels \
	    $itk_component(sesselector) $itk_component(name) $itk_component(player) \
	    $itk_component(password) $itk_component(mudname)

	updateMudUif
	updateUifList
	clearUif
	eval itk_initialize $args	
    }
    method configureButtons {} {
	if {[$CSesM sessionStarted]} {
	    $itk_component(ok)      configure -state disabled
	    $itk_component(rem)     configure -state disabled
	    $itk_component(start)   configure -state disabled
	    $itk_component(connect) configure -state disabled
	    $itk_component(stop)    configure -state normal
	} else {
	    $itk_component(ok)      configure -state normal
	    $itk_component(rem)     configure -state normal
	    $itk_component(start)   configure -state normal
	    $itk_component(connect) configure -state normal
	    $itk_component(stop)    configure -state disabled
	}
    }
    method activate {} {
	updateMudUif
	configureButtons

	iwidgets::Shell::activate
    }
    method startSes {} {
	# dont build connction
	newSes 0
    }
    method connect {} {
	# also start connection to mud
	newSes 1
    }    
    method newSes {aCon} {
        global TV
	set sesname $TV($this,name)
	if {[$CSesM exists $sesname]} {
	    $CSesM   newActSes $sesname
	    $CParent newSes
	    $CSesM   connectActSes $CParent $aCon
	    canc
	} else {
	    TInformer $itk_interior.mess -information \
		"A session '$sesname' does not exist.\
               \nYou may need to save the session\
               \nor just choose one."
	}
    }
    method stop {} {
	$CSesM stopSession
	configureButtons
    }
    method updateUifList {} {
	$itk_component(sesselector) delete 0 end
	foreach mn [$CSesM getSesNames] {
	    $itk_component(sesselector) insert end $mn
	}
    }
    method updateMudUif {} {
        $itk_component(mudname) clear
        foreach mudname [$CSesM getMudNames] {
            $itk_component(mudname) insert list end $mudname
        }
    }
    method save {} {
	global TV
	set name [string trim $TV($this,name)]
	if {![string compare $name ""]} {
	    TInformer $itk_interior.mess -information "You have to give a 'name' for the session!"
	    return
	}

	if {[exists $name]} {
	    TConfirmer $itk_interior.save -command "[code $this add $name $TV($this,player) $TV($this,password) $TV($this,mudname)]" \
		-question "The session '$name' already exists!\nDo You really want to overide it?" 
	    return
	}
	add $name $TV($this,player) $TV($this,password) $TV($this,mudname)
    }
    method exists {aName} { return [$CSesM exists $aName]}
    method remove {} {
	global TV
	set name [string trim $TV($this,name)]
	if {![exists $name]} {
	    TInformer $itk_interior.mess -information "A Session with the name '$name' does not exist!"
	    return
	}
	TConfirmer $itk_interior.remove -command "[code $this rem $name]" \
	    -question "Do you really want to remove the session '$name'?\nYou will loose all information." 	
    }
    method add {aName aPlayer aPassword aMudName} {
	$CSesM add $aName $aPlayer $aPassword $aMudName
	updateUifList
    }
    method rem {aName} {
	$CSesM rem $aName
	updateUifList
	clearUif
    }
    method selected {} {
	global TV
	set name [$itk_component(sesselector) getcurselection]
	if {![string compare "" $name]} { return }
	set ses  [$CSesM getSes $name]
	set TV($this,name) $name
	set TV($this,player)   [$ses player]
	set TV($this,password) [$ses password]
	set TV($this,mudname)  [$ses mudName]
    }
    method clearUif {} {global TV; set TV($this,name) "";set TV($this,player) "";set TV($this,password) ""; set TV($this,mudname) ""}
    method launchUif {}   { clearUif ; activate }
    method canc {}        { deactivate }

    ################################################


}

##########################################################################################################################
##########################################################################################################################
##########################################################################################################################
##########################################################################################################################
##########################################################################################################################
class TSession {
    inherit TESCParser

    variable CFilM
    variable CName    ;# must be unique
    variable CPlayer
    variable CPassword
    variable CMudName
    # CId: must be unique too: this is needed to request files and directories for the mud data to be stored
    #  => may never change again! 
    variable CId      
    private variable CSocket
    private variable CMainWindow
    private variable CMudder
    private variable CMapManager

    private variable COutput
    private variable CInput
    private variable CTicker

    variable CVarM  ;# Varaible manager
    variable CAliM  ;# alias manager
    variable CComM  ;# commands completition manager
    variable CTabM  ;# user tablist manager
    variable CActM  ;# 10 levels; evaluation order: 0 -> 9; levels 5-9 only after newline received!
    variable CSubM  ;# 10 levels; evaluation order: 0 -> 9; levels 5-9 only after newline received!
    variable CHilM  ;# 10 levels; evaluation order: 0 -> 9; levels 5-9 only after newline received!
    variable CNotM  ;# 10 levels; evaluation order: 0 -> 9; levels 5-9 only after newline received!
    
    variable CCurrentNotParsedLine    ;# -> need for telnet and esc sequences; only the not parsed/printed part
    variable CCurrentAsciiLine        ;# -> need for actions/highlights/etc
    variable CParseMode               ;# t: telnet, l: line, e: esc
    variable CTelnetProtocol        

    variable CLogFile
    variable CLogging
    variable CLogFID

    variable CButtonArea

    method killall {} {
	$CVarM clear
	$CAliM clear
	$CComM clear
	$CTabM clear
	for {set i 0} {$i<10} {incr i} {
	    $CActM($i) clear
	    $CSubM($i) clear
	    $CHilM($i) clear
	    $CNotM($i) clear
	}
    }
    variable CRegMatchGlobal
    variable CRegMatchVar
    variable CRegSubMatch0Var
    variable CRegSubMatch1Var
    variable CRegSubMatch2Var
    variable CRegSubMatch3Var
    variable CRegSubMatch4Var
    variable CRegSubMatch5Var
    variable CRegSubMatch6Var
    variable CRegSubMatch7Var
    variable CRegSubMatch8Var
    variable CRegSubMatch9Var


    private common CNL
    private common CCR
    private common CRS
    private common CNNL
    constructor {args} {
	TESCParser::constructor
    } {
	set CButtonArea ""
	set CSocket ""
	set CCurrentNotParsedLine ""
	set CCurrentAsciiLine     ""
	set CParseMode            l
	set CTelnetProtocol       null

	set CTicker               ""

	set CLogFile              ""
	set CLogging              0
	set CLogFID               ""
	
	set CNL   "\n"
	set CCR   "\r"
	set CRS   [format "%c" 30]
	set CNNL  "$CRS$CNL"

	# init managers
	set CVarM      [TVarManager    ::\#auto]
	set CAliM      [TAliasManager  ::\#auto]
	set CComM      [TCommandManager  ::\#auto]
	set CTabM      [TTabManager  ::\#auto]
	for {set i 0} {$i<10} {incr i} {
	    set CActM($i)   [TActionManager ::\#auto]
	    set CSubM($i)   [TSubstManager ::\#auto]
	    set CHilM($i)   [THilightManager ::\#auto]
	    set CNotM($i)   [TNotouchManager ::\#auto]
	}
	set CRegMatchGlobal     [$CVarM getGlobalVarName]
	set CRegMatchVar        [$CVarM getVarName RegExMatch]
	set CRegSubMatch0Var    [$CVarM getVarName RegExSubMatch0]
	set CRegSubMatch1Var    [$CVarM getVarName RegExSubMatch1]
	set CRegSubMatch2Var    [$CVarM getVarName RegExSubMatch2]
	set CRegSubMatch3Var    [$CVarM getVarName RegExSubMatch3]
	set CRegSubMatch4Var    [$CVarM getVarName RegExSubMatch4]
	set CRegSubMatch5Var    [$CVarM getVarName RegExSubMatch5]
	set CRegSubMatch6Var    [$CVarM getVarName RegExSubMatch6]
	set CRegSubMatch7Var    [$CVarM getVarName RegExSubMatch7]
	set CRegSubMatch8Var    [$CVarM getVarName RegExSubMatch8]
	set CRegSubMatch9Var    [$CVarM getVarName RegExSubMatch9]
	switch [llength $args] {
	    2 {
		set CFilM [lindex $args 0]
		readFile  [lindex $args 1]
	    }
	    6 {
		set CFilM     [lindex $args 0]
		set CName     [lindex $args 1]
		set CPlayer   [lindex $args 2]
		set CPassword [lindex $args 3]
		set CMudName  [lindex $args 4]
		set CId       [lindex $args 5]
		createFileSystem
	    }
	    default {
		error "Wrong number of arguments to constructor!"
	    }
	}
    }
    method evalMudText {} {
	global $CRegMatchGlobal
	#nodebug puts "===============EMT!!============"
	set line [$COutput getLastLine]
	set stopit 0
	for {set i 0} {$i<10} {incr i} {
	    #nodebug puts "---level: $i---------------"
	    # --- notouches ----
	    foreach nots [$CNotM($i) getAllNames] {
		if { [regexp -indices -- $nots $line range] } {
		    set stopit 1
		    break
		}
	    }
	    if {$stopit} { break }
	    # --- actions ----
	    foreach act [$CActM($i) getAllNames] {
		#nodebug puts "--A $i: '$act' -- '$line'"
		if { [regexp -- $act $line $CRegMatchVar $CRegSubMatch0Var $CRegSubMatch1Var $CRegSubMatch2Var $CRegSubMatch3Var $CRegSubMatch4Var $CRegSubMatch5Var $CRegSubMatch6Var $CRegSubMatch7Var $CRegSubMatch8Var $CRegSubMatch9Var] } {
		    #nodebug puts "--   OK"
		    $CInput takeCommand [$CActM($i) getValue $act]
		}
	    }
	    # --- substitution ----
	    foreach subs [$CSubM($i) getAllNames] {
		while { [regexp -indices -- $subs $line range] } {
		    $COutput replaceOnLastLine [lindex $range 0] [lindex $range 1] [$CSubM($i) getValue $subs]
		    set line [$COutput getLastLine]
		}
	    }
	    # --- highlights ----
	    foreach hl [$CHilM($i) getAllNames] {
		set offset 0
		while { [regexp -indices -- $hl [string range $line $offset end] range] } {		    
		    set s      [expr $offset + [lindex $range 0]]
		    set offset [expr $offset + [lindex $range 1]]
		    $COutput tagOnLastLine $s $offset [$CHilM($i) getValue $hl]
		}
	    }
	}
    }

    method getSocket {} { return $CSocket }
    method getOutput {} { return $COutput }
    method getVarM   {}  { return $CVarM }
    method getTabM   {}  { return $CTabM }
    method getComM   {}  { return $CComM }
    method getAliM   {}  { return $CAliM }
    method getActM   {n} { return $CActM($n) }
    method getSubM   {n} { return $CSubM($n) }
    method getHilM   {n} { return $CHilM($n) }
    method getNotM   {n} { return $CNotM($n) }
    method getCFile  {}  { return [$CFilM getMainSesConfFile $CId] }
    
    method writeMessage {aMsg} {
	$COutput fromSMM $aMsg
    }

    method connect {aMudM aMainWin aCon} {
	set CMainWindow $aMainWin
	set CMudder     [$aMainWin getMudderUif]
	set CMapManager [$aMainWin getMapManager]
	$CMapManager assignSession $this
	set COutput     [$CMudder getOutput]      
	set CInput      [$CMudder getEntryX]      
	set CButtonArea [$CMudder getButtonArea]
	$CButtonArea connect $CInput $CVarM

	set CTicker     [$aMainWin getTicker]
	$CTicker bindToSes $this $CInput

	set mud [$aMudM getMud $CMudName]
	if {$aCon} {
	    set CSocket [socket [$mud host] [$mud port]]
	    fconfigure $CSocket -blocking 0 -buffering none -translation {lf lf}
	    fileevent  $CSocket readable [code $this readMud]
	    $COutput fromSMMImportant "Connection opened!"
	} else {
	    set CSocket ""
	}
	$CMudder bindToSes $this $CTicker $CMapManager;# CSocket must be initialized already here, buttonarea too!
    }
    method getButtonArea {} {return $CButtonArea }

    method disconnect {} {
	if {[string compare "" $CSocket]!=0} {
	    close $CSocket
	    set CSocket ""
	    $COutput fromSMMImportant "Connection closed!"
	}
	$CMainWindow sesDisconnected
	$CButtonArea clear
	$CInput unbindFromSes
	$CTicker unbindFromSes
    }
    method readMudFromFile {aFileName} {
	if {![file exists $aFileName]} {
	    bell
	    return
	}
	set fid [open $aFileName "r"]
	set CCurrentNotParsedLine ""
	set c 0
	while {![eof $fid]} {
	    gets $fid line
	    evalSingleLine "\n$line" 1

	    incr c
	    if {$c>9} {
		$COutput see end
		update idletasks
		set c 0
	    }
	}

	close $fid
	$COutput see end
	update idletasks
    }
    method readMud {} {
	set x [read $CSocket]
	if ([string compare "" $x]==0) {
	    disconnect
	}
	regsub -all -- $CCR $x {} x
	regsub -all -- $CNL $x $CNNL x

	set p $CCurrentNotParsedLine$x
	set CCurrentNotParsedLine ""
	set c 0
	foreach line [split $p $CRS ] {
	    evalSingleLine "$line" 1
	    incr c
	    if {$c>19} {
		$COutput see end
		update idletasks
		set c 0
	    }
	}

	$COutput see end
	update idletasks
    }
    proc charToInt {aChar} {
	for {set i 0} {$i<256} {incr i} {
	    eval set comp "[format \"\\x%x\" $i]"
	    if {[string compare $comp $aChar]==0} {
		break
	    }
	}
	return $i
    }

    method logfile {aFile}  {
	if {[logfileExists]} {
	    flush $CLogFID
	    close $CLogFID
	} 
	set CLogFile $aFile 
	set CLogFID [open $CLogFile {WRONLY CREAT APPEND}]
    }
    method logfileExists {} {
	if {[string compare "" $CLogFile]} {
	    return 1
	} else {
	    return 0
	}
    }
    method logOn {} { 
	set CLogging 1 
    }
    method logOff {} { 
	set CLogging 0 
	if {[logfileExists]} {
	    flush $CLogFID
	    close $CLogFID
	} 
    }
    method logToggle {} { 
	set CLogging [expr !$CLogging] 
	if {[isLogging]} {
	    logOn
	} else {
	    logOff
	}
    }
    method isLogging {} {return $CLogging}

    method evalSingleLine {aPart args} {
	# first check if a esc for telnet sequence is
	# in the line: \xff (telnet:iac) \x1b (esc) 

	#nodebug puts "|$aPart|"

	switch -exact -- $CParseMode {
	    t {
		switch -exact -- $CTelnetProtocol {
		    null {
			if {[string length $aPart]>0} {
			    set nextChar [string index $aPart 0]
			    switch -exact -- $nextChar {
				\xfb {
				    #nodebug puts will!
				    set CTelnetProtocol will 
				}
				\xfc {
				    #nodebug puts wont!;
				    set CTelnetProtocol wont
				}
				default {
				    puts "ERROR: telnet parse, unknown protocol, '[charToInt $nextChar]'"
				    set CParseMode l
				}
			    }
			    evalSingleLine [string range $aPart 1 end]
			}
		    }
		    will {
			if {[string length $aPart]>0} {
			    set nextChar [string index $aPart 0]
			    switch -exact -- $nextChar {
				\x01 { $CInput hideInput}
				default {
				    puts "ERROR: telnet parse, unknown will command, '[charToInt $nextChar]'"
				}
			    }
			    set CTelnetProtocol null
			    set CParseMode l
			    evalSingleLine [string range $aPart 1 end]
			}
		    }
		    wont {
			if {[string length $aPart]>0} {
			    set nextChar [string index $aPart 0]
			    switch -exact -- $nextChar {
				\x01 { $CInput showInput}
				default {
				    puts "ERROR: telnet parse, unknown wont command, '[charToInt $nextChar]'"
				}
			    }
			    set CTelnetProtocol null
			    set CParseMode l
			    evalSingleLine [string range $aPart 1 end]
			}
		    }
		}
	    }
	    l {
		if {[regexp -- "(\[^\x1b\xff\]*)(\[\x1b\xff\])(.*)" $aPart dummy b c d]} {
		    #b: contains all before the command seq (esc or telnet)
		    #c: contains the first command seq char -> may be \x1b or \xff
		    #d: contains the rest of the string

		    #. first write away the first part
		    writeMudText $b			
		    if {[string compare "\x1b" $c] == 0} {
			# esc seq
			
			#. check if the complete sequence is in
			if {[escAnalyse $d]} {
			    #nodebug puts "<<$CESCFinal>>$CESCParameters<<"
			    switch -exact -- $CESCFinal {
				m { $COutput setColors $CESCParameters }
				s { $COutput rememberCursorPosition }
				u { $COutput returnToCursorPosition }
				f - H {
				    $COutput moveCursorTo $CESCParameters
				}
				h { 
				    # cursor on??
				}
				l { 
				    # cursor off??
				}
				r { $COutput setScrollRegion $CESCParameters	}
				J { 
				    switch -- $CESCParameters {
					""      { $COutput clearToStart }
					"1"     { $COutput clearToEnd }
					default { $COutput clear }
				    }
				}
				K { 
				    switch -- $CESCParameters {
					"1"     { $COutput clearToStartOfLine }
					default { $COutput clearToEndOfLine }
				    }
				}
				P { $COutput delChars $CESCParameters	}
				L { $COutput addLinesBeforeCurPos $CESCParameters	}
				M { $COutput remLinesAfterCurPos $CESCParameters	}
				A { $COutput moveup $CESCParameters	}
				B { $COutput movedown $CESCParameters	}
				C { $COutput moveright $CESCParameters	}
				D { $COutput moveleft $CESCParameters }
				7 - 8 {
				    # ??
				}
				default {
				    msgError "ESC Error:\nFinal: '$CESCFinal'\nParameter: '$CESCParameters'\nIntermediate: '$CESCIntermediates'\nFollowed by: \[$CESCParsedText\]"
				}
			    }
			    evalSingleLine "$CESCParsedText"
			} else {			    
			    set CCurrentNotParsedLine "$c$d"
			    if {[string length $CCurrentNotParsedLine]>100} {
				set CCurrentNotParsedLine [string range $CCurrentNotParsedLine 1 end]
				msgError "ERROR: seq not complete or not known: ESC+'$d'\n--------------------------------\n'\[$c$d'\]"
			    }
			}


		    } else {
			# telnet seq
			# parsed seq's:
			#  \xff\xfb\x01 -> echo input
			#  \xff\xfc\x01 -> dont echo input
			
			# parse
			set CParseMode t
			evalSingleLine $d
		    }
		} else {
		    writeMudText $aPart
		}
	    }
	}
	if {[llength $args]>0} {
	    evalMudText 
	}
    }
    method writeMudText {aPart} {
	# -----------------------------------------------
	# screen output
	$COutput fromMud $aPart
	# file logging
	if {$CLogging} {
	    puts -nonewline $CLogFID $aPart
	}
    }


    method show     {} { puts "$CId -- $CName || $CPlayer $CMudName" }
    method name     {} { return $CName }
    method player   {} { return $CPlayer }
    method password {} { return $CPassword }
    method mudName  {} { return $CMudName }
    method id       {} { return $CId }
    method createFileSystem {} {
	file mkdir    [$CFilM getSesDir    $CId]

	# session information
	set    fid [open [$CFilM getSesDataFile $CId] "w+"]
	puts  $fid 1 ;# file version
	puts  $fid [id]
	puts  $fid [name]
	puts  $fid [player]
	puts  $fid [password]
	puts  $fid [mudName]
	close $fid

	# main session configuration file
	set    fid [open [$CFilM getMainSesConfFile $CId] "CREAT RDWR"]
	close $fid
    }
    method readFile {aFile} {
	set    fid [open $aFile "r"]
	gets  $fid version
	gets  $fid CId
	gets  $fid CName
	gets  $fid CPlayer
	gets  $fid CPassword
	gets  $fid CMudName
	close $fid
    }
    method removeFileSystem {} { 
	file delete -force -- [$CFilM getSesDir    $CId]
    }
    method wipeout {} {
	removeFileSystem
    }
}
