class TAliasManager {
    inherit TNVContainer

    method exists {aCom} {
	set aliasName [lindex $aCom 0]
	return [TNVContainer::exists $aliasName]
    }
    method getAliasSubstitution {aCom} {
	set aliasName [lindex $aCom 0]
	set aVal [getValue $aliasName] 
	
	set part1       ""	
	set l           [string length $aVal]

	set bl 0 ; #bracket level
	set mode t ;# toplevel
	# q: in quotes
	# b: in brackets

	for {set i 0} {$i<$l} {incr i} {
	    set c [string index $aVal $i]
	    
	    switch $mode {
		t {
		    switch -exact -- $c {
			\$ {
			    incr i
			    for {set end $i} {$end<$l} {incr end} {
				if {[regexp -- {[^0-9]} [string index $aVal $end]]} {break}
			    }
			    incr end -1
			    set varname [string range $aVal $i $end]
			    
			    if {[regexp -- {^[0-9]+} $varname]} {
				if {$varname == 0 } {
				    set varval [lrange $aCom 1 end]
				} else {
				    set varval [lindex $aCom $varname]
				}
				append part1 $varval
			    } else {
				append part1 "\$"
				append part1 "$varname"
			    }

			    set i $end

			}
			\" {
			    set mode q
			    append part1 $c
			}
			\\ {
			    incr i
			    set cc [string index $aVal $i]
			    if {[string compare "\$" $cc]==0} {
				append part1 $cc
			    } else {
				append part1 $c
				append part1 $cc
			    }
			}
			\{ {
			    set mode b
			    set bl 1
			    append part1 $c
			}
			default {
			    append part1 $c
			}
		    }
		}
		b {
		    switch -exact -- $c {
			\{ {
			    incr bl
			    append part1 $c
			}
			\} {
			    incr bl -1
			    append part1 $c
			    if {$bl==0} {
				set mode t
			    }
			}
			\\ {
			    append part1 \\
			    incr i
			    append part1 [string index $aVal $i]
			}
			default {
			    append part1 $c
			}
		    }
		}
		q {
		    switch -exact -- $c {
			\$ {
			    incr i
			    for {set end $i} {$end<$l} {incr end} {
				if {[regexp -- {[^0-9]} [string index $aVal $end]]} {break}
			    }
			    incr end -1
			    set varname [string range $aVal $i $end]
			    
			    if {$varname == 0 } {
				set varval [lrange $aCom 1 end]
			    } else {
				set varval [lindex $aCom $varname]
			    }
			    append part1 $varval
			    set i $end

			}
			\" {
			    set mode t
			    append part1 $c
			}
			\\ {
			    append part1 \\
			    incr i
			    append part1 [string index $aVal $i]
			}
			default {
			    append part1 $c
			}
		    }
		}
	    }
	}


	return $part1
    }


}

