class TEntryX {
    inherit itk::Widget

    private variable CSes
    private variable CSocket
    private variable COutput
    private variable CButtonArea

    private variable CVarM
    private variable CComM
    private variable CAliM
    private variable CActM
    private variable CSubM
    private variable CHilM
    private variable CTabM
    private variable CNotM

    private variable CShowInput

    private variable CTabPos
    private variable CTabCycle
    private variable CTabBegString
    private variable CTabEndString
    private variable CTabComplSubList

    private variable CComChar
    private variable CParse

    private variable CCommandFIFO ;# object

    private variable CKeyArray
    variable CTicker
    variable CFilM
    variable CMapM

    variable CPrintOutput

    constructor {aFilM args} {
	global _TEntryX	
	set CFilM    $aFilM
	set CTicker  ""
	set CSes     ""
	set CVarM    ""
	set CAliM    ""
	set CComM    ""
	set CTabM    ""
	set CButtonArea ""
	for {set i 1} {$i<3} {incr i} {
	    set CActM($i) ""
	    set CSubM($i) ""
	    set CHilM($i) ""
	}


	set CPrintOutput 1
	set CShowInput 1
	set CParse     1
	resetTabCycle

	set CComChar "\#"

	set CCommandFIFO       [TLimitedFIFO \#auto 20]

	itk_component add com {
	    entry  $itk_interior.com -textvariable _TEntryX($this) -bd 2 \
		-font mudDef -fg $TColor::FGCom -bg $TColor::BGCom
	} {ignore -background}
	pack $itk_component(com) -fill both -expand 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

	bind $itk_component(com)  <Any-KeyPress>          [code $this evalKeyPress]
	bind $itk_component(com)  <Return>                [code $this processMudCom]
	bind $itk_component(com)  <KeyPress-Up>           [code $this prevMudCom]
	bind $itk_component(com)  <KeyPress-Down>         [code $this nextMudCom]
	bind $itk_component(com)  <KeyPress-Tab>          [code $this tabCompletition]
	bind $itk_component(com)  <Control-KeyPress-Tab>  [code $this insertTab]
	
	eval itk_initialize $args
    }
    method resizeHist {aSize} { $CCommandFIFO resize $aSize }
    method isBoundToSes {} {
	if {[string compare "" $CSes]} { return 1 } else { return 0 }
    }
    method unbindFromSes {} {
	set CSes ""
	set CMapM ""
	set CTicker ""
	foreach seq [array names CKeyArray] {
	    bind $itk_component(com) $seq {}
	    unset CKeyArray($seq) 
	}
    }
    method bindToSes {aSes aTicker aMapM} {
	set CTicker     $aTicker
	set CSes        $aSes
	set CMapM       $aMapM
	set CVarM      [$CSes getVarM]
	set CAliM      [$CSes getAliM]
	set CComM      [$CSes getComM]
	set CTabM      [$CSes getTabM]
	for {set i 0} {$i<10} {incr i} {
	    set CActM($i)   [$CSes getActM $i]
	    set CSubM($i)   [$CSes getSubM $i]
	    set CHilM($i)   [$CSes getHilM $i]
	    set CNotM($i)   [$CSes getNotM $i]
	}

	set CSocket     [$CSes getSocket]
	set COutput     [$CSes getOutput]
	set CButtonArea [$CSes getButtonArea]
	evalfile    [$CSes getCFile]
    }
    ### --- bindings -------------------------
    method tabCompletition {} 
    method insertTab {} {
	$itk_component(com) insert insert "\t"
	resetTabCycle
    }
    method evalKeyPress {} {
	resetTabCycle
    }
    method prevMudCom {} {
	global _TEntryX
	set _TEntryX($this) [$CCommandFIFO getUp]
	$itk_component(com) icursor end	
	resetTabCycle
    }
    method nextMudCom {} {
	global _TEntryX
	set _TEntryX($this) [$CCommandFIFO getDown]
	$itk_component(com) icursor end	
	resetTabCycle
    }
    method processMudCom {} {
	global _TEntryX
	
	if {[isBoundToSes]} {
	    takeCommand $_TEntryX($this)
	    if {$CShowInput} {
		# only insert into fifo, if command may be shown too
		$CCommandFIFO insert $_TEntryX($this)
	    }
	    set _TEntryX($this) ""
	    resetTabCycle
	} else {
	    TInformer $itk_interior.mess -vanishafter 3 -information "There is no active Session!"
	}
    }
    ### --- helpers -----------------------------
    method resetTabCycle {} { set CTabCycle 0 }
    method takeFocus {} { focus $itk_component(com) }
    method printf {aStr} { if {$CPrintOutput} {$COutput fromSMM "$aStr"} }
    method hideInput {} { 
 	set CShowInput 0 
 	$itk_component(com) configure -show *
    } 
    method showInput {} { 
	set CShowInput 1 
	$itk_component(com) configure -show ""
    } 
    ### --- command eavaluation --------------------
    method splitCommand {aCom} 
    method substCommandVars {aCom args}
    method evalCommand {aCom} 
    method isSMMCommand {aCom} {
	set firstWord [lindex $aCom 0]
	set firstChar [string index $firstWord 0]
	if { [string compare $CComChar $firstChar] == 0 } {
	    return true
	} else {
	    return false
	}
    }
    method substCommandAlias {aCom} {
	if {[$CAliM exists $aCom]} {
	    splitCommand [$CAliM getAliasSubstitution $aCom]
	} else {
	    if {[isSMMCommand $aCom]} {
		evalCommand $aCom
	    } else {
		sendCommand "$aCom"
	    }
	}
    }
    method takeCommand {aCom} { 
	if {$CParse} {
	    splitCommand $aCom 
	} else {
	    if {[isSMMCommand $aCom]} {
		evalCommand $aCom
	    } else {
		sendCommand "$aCom"
	    }
	}
    }
    method sendCommand {aCom} {
	if {$CShowInput} {
	    $COutput fromInput "$aCom"
	}
	if {[string compare "" $CSocket]!=0} {
	    if {[catch {puts $CSocket $aCom}]} {
		TInformer $itk_interior.mess -vanishafter 3 -information "Connection to the mud failed!"
	    }
	}
    }
    method evalfile {aFile} {
	set fileId [open $aFile r]
	set linesList       [split "[read $fileId]\n" "\n"]
	close $fileId

	set linesListLength [llength $linesList]
	set linenum         1
	set realLine [lindex $linesList 0]
	set line ""
	for {set i 1} {$i<$linesListLength} {incr i} {

	    set line  [string trim [lindex $linesList $i]]
	    set bl    [bracketLevel $realLine]
	    
	    switch -- $bl  {
		-1 {
		    printf "Bracket ERROR in line $linenum:"
		    printf "$line"
		    break;
		}
		-2 {
		    printf "Quote ERROR in line $linenum:"
		    printf "$line"
		    break;
		}
		0 {
		    if {[string length [string trim $realLine]]!=0} {
			takeCommand $realLine
		    }
		    set realLine "$line"
		    set line ""
		}
		default {
		    set realLine "$realLine$line"
		}
	    }
	    incr linenum
	}
	if {[expr ([string length [string trim $realLine]]!=0) || ([string length [string trim $line]]!=0)]} {
	    printf "Syntax Error at end of file"
	}

    }
}





############################################################################

body TEntryX::evalCommand {aCom} {
    set com [lindex $aCom 0]
    set com [string range $com 1 end]

    if {[regexp -- {[0-9]+} $com dummy]} {
	set times $com
	set com times
    }

    #. completition of commands
    set com [$CComM getCom $com]

    switch -exact -- $com {
	"xxxx" { $COutput XXX [lrange $aCom 1 end] }
	# d--------------------------------------------------------------------------------
	"smm" {
	    set commandSet [lindex $aCom 1]
	    set subCommand [lindex $aCom 2]

	    switch -- $commandSet {
		"commandoutput" {
		    switch -- $subCommand {
			no - No - NO - false - False - FALSE - off - Off - OFF - 0 {
			    set CPrintOutput 0
			}
			default {
			    set CPrintOutput 1
			}
		    }
		}
		"file" {
		    switch -- $subCommand {
			"readasmud" {
			    $CSes readMudFromFile [lindex $aCom 3]
			}
		    }
		}
	    }
	}
	# d--------------------------------------------------------------------------------
	"map" {
	    set commandSet [lindex $aCom 1]
	    set subCommand [lindex $aCom 2]

	    set mapnamearg  [lindex $aCom 3]
	    set maplevelarg [lindex $aCom 4]
	    set posxarg     [lindex $aCom 5]
	    set posyarg     [lindex $aCom 6]

	    set existsReturnVar [lindex $aCom 5]
	    set existsRoomReturnVar [lindex $aCom 7]
	    set getExitReturnVar [lindex $aCom 8]
	    
	    set getExitCommand [lindex $aCom 7]

	    set bgtype [lindex $aCom 3]
	    set bgcate [lindex $aCom 4]
	    set bgname [lindex $aCom 5]

	    set ziftext   [lindex $aCom 3]

	    set lpos      [lindex $aCom 3]
	    set stufftype [lindex $aCom 4]
	    set stuffcate [lindex $aCom 5]
	    set stuffname [lindex $aCom 6]

	    set exarg  [lindex $aCom 3]

	    set expos  [lindex $aCom 3]
	    set excom  [lindex $aCom 4]
	    set exmapn  [lindex $aCom 5]
	    set exmapl  [lindex $aCom 6]
	    set excx  [lindex $aCom 7]
	    set excy  [lindex $aCom 8]
	    set exdx  [lindex $aCom 9]
	    set exdy  [lindex $aCom 10]
	    set exdoor  [lindex $aCom 11]
	    set exdoorco  [lindex $aCom 12]
	    set exdoorcc  [lindex $aCom 13]
	    set exthick  [lindex $aCom 14]
	    set excolor  [lindex $aCom 15]

	    switch -- $commandSet {
		"player" {
		    switch -- $subCommand {
			"useexit"                -
			"useexitwithcommand"     -			
			"followexit"             -
			"followexitwithcommand"  {
			    $CMapM movePlayer $subCommand $exarg
			}
			"speedwalk" {
				$CMapM speedy $mapnamearg $maplevelarg $posxarg $posyarg
			}
		    }
		}
		"devmode" {
		    switch -- $subCommand {
			on - ON - 1 - true - TRUE - yes - YES {
			    $CMapM setDevMode 1
			}
			default {
			    $CMapM setDevMode 0			
			}
		    }
		}
		"zoom" {
		    switch -- $subCommand {
			"accept"    { $CMapM acceptRoom }
			"reset"     { $CMapM resetRoom }
			"clear"     -
			"remove"    { $CMapM zifRemoveRoom }
			"setbg"     { $CMapM zifSetBg $bgtype $bgcate $bgname }
			"setstuff"  { $CMapM zifSetStuff $lpos $stufftype $stuffcate $stuffname }
			"remstuff"  { $CMapM zifRemStuff $lpos }
			"remtext"   { $CMapM zifRemText }
			"settext"   { $CMapM zifSetText $ziftext }
			"remexit"   { $CMapM zifRemExit $expos }
			"setexit"   { 
			    $CMapM zifSetExit \
				$expos $excom $exmapn $exmapl \
				$excx $excy $exdx $exdy \
				$exdoor $exdoorco $exdoorcc \
				$exthick $excolor
			}
		    }
		}
		"room" {
		    switch -- $subCommand {
			"getexitwithcommand" {
			    $CVarM add $getExitReturnVar \
				[$CMapM getExitWithCommand \
				     $mapnamearg $maplevelarg $posxarg $posyarg $getExitCommand]
			}
			"exists" {
			    $CVarM add $existsRoomReturnVar \
				[$CMapM existsRoom $mapnamearg $maplevelarg $posxarg $posyarg]
			}
		    }
		}
		"map" {
		    switch -- $subCommand {
			"exists" {
			    $CVarM add $existsReturnVar [$CMapM existsMap $mapnamearg $maplevelarg]
			}
			"change" {
			    $CMapM changeMap $mapnamearg $maplevelarg
			}
			"create" {
			    $CMapM createMap $mapnamearg $maplevelarg
			}
		    }
		}
		"pos" {
		    switch -- $subCommand {
			"getzoom" {
			    set pos [$CMapM getZoomPos]

			    $CVarM add $mapnamearg  [$pos getMapName]
			    $CVarM add $maplevelarg [$pos getMapLevel]
			    $CVarM add $posxarg     [$pos getX]
			    $CVarM add $posyarg     [$pos getY]
			}
			"setzoom" {
			    if {[$CMapM existsMap $mapnamearg $maplevelarg]} {
				$CMapM setZoomPos $mapnamearg $maplevelarg $posxarg $posyarg
			    } else {
				printf "Map '$mapnamearg' (level $maplevelarg) does not exists!"
			    }

			}
			"getplayer" {
			    set pos [$CMapM getPlayerPos]

			    $CVarM add $mapnamearg  [$pos getMapName]
			    $CVarM add $maplevelarg [$pos getMapLevel]
			    $CVarM add $posxarg     [$pos getX]
			    $CVarM add $posyarg     [$pos getY]
			}
			"setplayer" {
			    if {[$CMapM existsMap $mapnamearg $maplevelarg]} {
				$CMapM setPlayerPos $mapnamearg $maplevelarg $posxarg $posyarg
			    } else {
				printf "Map '$mapnamearg' (level $maplevelarg) does not exists!"
			    }

			}
		    }
		}
		
		
	    } ;# this is the end of switch c1: first arg to #map
	    

	    # switch of map ends here
	}
	# d--------------------------------------------------------------------------------
	"tickon" { $CTicker start }
	"tickoff" { $CTicker stop}
	"tickreset" { $CTicker reset }
	"tickremall" { $CTicker clear }
	"ticksize" {
	    switch [llength $aCom] {
		2 {
		    $CTicker setSize [lindex $aCom 1]
		}
		default { bell; printf "Wrong number of arguments!" }
	    }	    	    	    
	}
	"tickaddcommand" {
	    switch [llength $aCom] {
		3 {
		    $CTicker addTickCommand [lindex $aCom 1] [lindex $aCom 2]
		}
		default { bell; printf "Wrong number of arguments!" }
	    }	    	    	    
	}
	"tickremcommand" {
	    switch [llength $aCom] {
		2 {
		    $CTicker remTickCommand [lindex $aCom 1]
		}
		default { bell; printf "Wrong number of arguments!" }
	    }	    	    	    
	}
	"tickshowall" {
	    set secl [$CTicker getAllTimes] 
	    if {[llength $secl] == 0} {
		printf "No tickcommands defined!"
	    } else {
		foreach sec $secl {
		    printf "Tick [format {%4d} $sec]: [$CTicker getCommand $sec]"
		}
	    }
	}
	"tickshow" {
	    switch [llength $aCom] {
		2 {
		    set sec [lindex $aCom 1]
		    if {[$CTicker existsCommand $sec]} { 
			set com [$CTicker getCommand $sec]
		    } else {
			set com "not existing!"
		    }
		    printf "Tick [format {%4d} $sec]: $com"
		}
		default { bell; printf "Wrong number of arguments!" }
	    }	    	    	    
	}
	# d--------------------------------------------------------------------------------
	"times" {
	    for {set i 0} {$i < $times} {incr i} {
		takeCommand [lrange $aCom 1 end]
	    }
	}
	# d--------------------------------------------------------------------------------
	"keycom" {
	    switch [llength $aCom] {
		3 {
		    set seq [lindex $aCom 1]
		    set com [lindex $aCom 2]
		    set CKeyArray($seq) $com
		    bind $itk_component(com) $seq "[code $this takeCommand $com];break"
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'keycom'!"
		}
	    }	    	    	    
	}
	# d--------------------------------------------------------------------------------
	"addrow" {
	    switch [llength $aCom] {
		2 {
		    if {![$CButtonArea addButtonRow [lindex $aCom 1]]} {
			printf "Cannot add buttonrow '[lindex $aCom 1]'!"
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'addbuttonrow'!"
		}
	    }	    	    	    
	}
	"remrow" {
	    switch [llength $aCom] {
		2 {
		    if {![$CButtonArea remButtonRow [lindex $aCom 1]]} {
			printf "Cannot remove buttonrow '[lindex $aCom 1]'!"
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'rembuttonrow'!"
		}
	    }	    	    	    
	}
	"addbutton" {
	    switch [llength $aCom] {
		5 {
		    if {![$CButtonArea addButton \
			      [lindex $aCom 1] [lindex $aCom 2] \
			      [lindex $aCom 3] [lindex $aCom 4]]} {
			printf "Cannot add button '[lindex $aCom 1]' - [lindex $aCom 2]!"
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'addbutton'!"
		}
	    }	    	    	    
	}
	"rembutton" {
	    switch [llength $aCom] {
		3 {
		    if {![$CButtonArea remButton [lindex $aCom 1] [lindex $aCom 2]]} {
			printf "Cannot remove button '[lindex $aCom 1]' - [lindex $aCom 2]!"
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'rembutton'!"
		}
	    }	    	    	    
	}
	"addlabel" {
	    switch [llength $aCom] {
		5 {
		    if {![$CButtonArea addLabel \
			      [lindex $aCom 1] [lindex $aCom 2] \
			      [lindex $aCom 3] [lindex $aCom 4]]} {
			printf "Cannot add label '[lindex $aCom 1]' - [lindex $aCom 2]!"
		    }
		}
		4 {
		    if {![$CButtonArea addLabel \
			      [lindex $aCom 1] [lindex $aCom 2] \
			      [lindex $aCom 3] [string length [lindex $aCom 3]]]} {
			printf "Cannot add label '[lindex $aCom 1]' - [lindex $aCom 2]!"
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'addlabel'!"
		}
	    }	    	    	    
	}
	"remlabel" {
	    switch [llength $aCom] {
		3 {
		    if {![$CButtonArea remLabel [lindex $aCom 1] [lindex $aCom 2]]} {
			printf "Cannot remove label '[lindex $aCom 1]' - [lindex $aCom 2]!"
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'remlabel'!"
		}
	    }	    	    	    
	}
	"setlabeltext" {
	    switch [llength $aCom] {
		4 {
		    if {![$CButtonArea setLabelText [lindex $aCom 1] [lindex $aCom 2] [lindex $aCom 3]]} {
			printf "Cannot set text of label '[lindex $aCom 1]' - [lindex $aCom 2]!"
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'setlabeltext'!"
		}
	    }	    	    	    
	}
	"addvarentry" {
	    switch [llength $aCom] {
		5 {
		    if {![$CButtonArea addVarEntry \
			      [lindex $aCom 1] [lindex $aCom 2] \
			      [lindex $aCom 3] [lindex $aCom 4]]} {
			printf "Cannot add varentry '[lindex $aCom 1]' - [lindex $aCom 2]!"
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'addvarentry'!"
		}
	    }	    	    	    
	}
	"remvarentry" {
	    switch [llength $aCom] {
		3 {
		    if {![$CButtonArea remVarEntry [lindex $aCom 1] [lindex $aCom 2]]} {
			printf "Cannot remove varentry '[lindex $aCom 1]' - [lindex $aCom 2]!"
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'remvarentry'!"
		}
	    }	    	    	    
	}
	"addvarlabel" {
	    switch [llength $aCom] {
		5 {
		    if {![$CButtonArea addVarLabel \
			      [lindex $aCom 1] [lindex $aCom 2] \
			      [lindex $aCom 3] [lindex $aCom 4]]} {
			printf "Cannot add varentry '[lindex $aCom 1]' - [lindex $aCom 2]!"
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'addvarentry'!"
		}
	    }	    	    	    
	}
	"remvarlabel" {
	    switch [llength $aCom] {
		3 {
		    if {![$CButtonArea remVarLabel [lindex $aCom 1] [lindex $aCom 2]]} {
			printf "Cannot remove varentry '[lindex $aCom 1]' - [lindex $aCom 2]!"
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'remvarentry'!"
		}
	    }	    	    	    
	}
	"addvarchooser" {
	    switch [llength $aCom] {
		5 {
		    if {![$CButtonArea addVarChooser \
			      [lindex $aCom 1] [lindex $aCom 2] \
			      [lindex $aCom 3] [lindex $aCom 4]]} {
			printf "Cannot add varchooser '[lindex $aCom 1]' - [lindex $aCom 2]!"
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'addvarchooser'!"
		}
	    }	    	    	    
	}
	"remvarchooser" {
	    switch [llength $aCom] {
		3 {
		    if {![$CButtonArea remVarChooser [lindex $aCom 1] [lindex $aCom 2]]} {
			printf "Cannot remove varchooser '[lindex $aCom 1]' - [lindex $aCom 2]!"
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'remvarchooser'!"
		}
	    }	    	    	    
	}
	"addvarchooseritem" {
	    switch [llength $aCom] {
		4 {
		    if {![$CButtonArea addVarChooserItem [lindex $aCom 1] [lindex $aCom 2] [lindex $aCom 3]]} {
			printf "Cannot add item to varchooser '[lindex $aCom 1]' - [lindex $aCom 2]!"
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'addvarentryitem'!"
		}
	    }	    	    	    
	}
	"remvarchooseritem" {
	    switch [llength $aCom] {
		4 {
		    if {![$CButtonArea remVarChooserItem [lindex $aCom 1] [lindex $aCom 2] [lindex $aCom 3]]} {
			printf "Cannot rem item from varchooser '[lindex $aCom 1]' - [lindex $aCom 2]!"
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'remvarentryitem'!"
		}
	    }	    	    	    
	}
	# d--------------------------------------------------------------------------------
	"killall" {
	    switch [llength $aCom] {
		1 {
		    $CSes killall
		    printf "Everything cleared!"
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'killall'!"
		}
	    }	    	    
	}
	# d--------------------------------------------------------------------------------
	"if" {
	    set numargs [llength $aCom]
	    set i       3
	    if {$numargs < $i} {
		bell
		printf "Wrong number of arguments to 'if'!"
	    }
	    set express [substCommandVars [lindex $aCom 1] 1]
	    set command [lindex $aCom 2]
	    set cc "if {[expr $express]} { takeCommand {$command} }"

	    while {$i<$numargs} {
		if {[string match "else" [lindex $aCom $i]]} {
		    incr i
		    set command [lindex $aCom $i]
		    incr i
		    append cc " else { takeCommand {$command} }"
		} elseif {[string match "elseif" [lindex $aCom $i]]} {
		    incr i
		    set express [substCommandVars [lindex $aCom $i] 1]
		    incr i
		    set command [lindex $aCom $i]
		    incr i
		    append cc " elseif {[expr $express]} { takeCommand {$command} }"
		} else {
		    bell
		    printf "Wrong arguments to 'if'"
		}
	    }

	    if {[catch { eval $cc }]} {
		printf "Error while executing 'if'!"
	    } 
	}
	"while" {
	    switch [llength $aCom] {
		3 {
		    while { 1 } {
			set express [substCommandVars [lindex $aCom 1] 1]
			set command [lindex $aCom 2]
			if {[catch { eval set nvv [expr $express]}]} {
			    printf "Expression '$express' cannot be evaluated!"
			    break
			} else {
			    if {$nvv} {
				takeCommand $command
			    } else {
				break
			    }
			}
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'while'!"
		}
	    }	    	    
	}
	"math" {
	    switch [llength $aCom] {
		3 {
		    set varname [lindex $aCom 1]
		    set express [substCommandVars [lindex $aCom 2] 1]
		    
 		    if {[catch { eval set nvv [expr $express]}]} {
 			printf "Expression '$express' cannot be evaluated!"
 		    } else {
 			$CVarM add $varname $nvv
 		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'math'!"
		}
	    }	    	    
	}
	"incr" {
	    switch [llength $aCom] {
		3 {
		    set varname [lindex $aCom 1]
		    set ival    [lindex $aCom 2]
		    if {![$CVarM exists $varname]} {
			printf "Variable '$varname' doesnt exist!"
			return
		    }
		    set varvalue [$CVarM getValue $varname]
		    if {[catch {set nvv [expr $varvalue + $ival]}]} {
			printf "Expression '$varvalue + $ival' cannot be evaluated!"
		    } else {
			$CVarM add $varname $nvv
		    }
		}
		2 {
		    set varname [lindex $aCom 1]
		    if {![$CVarM exists $varname]} {
			printf "Variable '$varname' doesnt exist!"
			return
		    }
		    set varvalue [$CVarM getValue $varname]
		    if {[catch {set nvv [expr $varvalue + 1]}]} {
			printf "Value '$varvalue' of variable '$varname' can't be increased."
		    } else {
			$CVarM add $varname $nvv
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'incr'!"
		}
	    }	    	    
	}
	# d--------------------------------------------------------------------------------
	"logfile" {
	    switch [llength $aCom] {
		2 {
		    set filename [lindex $aCom 1]
		    $CSes logfile $filename
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'logfile'!"
		}
	    }	    
	}
	"log" {
	    if {![$CSes logfileExists]} {
		printf "No logfile defined yet!"
		return
	    }
	    switch [llength $aCom] {
		2 {
		    switch -- [lindex $aCom 1] {
			0 {
			    $CSes logOff
			}
			1 {
			    $CSes logOn
			}
			default {
			    bell
			    printf "Wrong argument to 'log'!"
			}
		    }
		}
		1 {
		    $CSes logToggle
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'logfile'!"
		}
	    }
	    if {[$CSes isLogging]} {
		printf "SMM: logging turned on!"
	    } else {
		printf "SMM: logging turned off!"
	    }
	}
	# d--------------------------------------------------------------------------------
	"char" {
	    switch [llength $aCom] {
		2 {
		    set arg [lindex $aCom 1]
		    if {[string length $arg]==1} {
			set CComChar $arg
		    } else {
			printf "Wrong arguments to 'char'!"
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'char'!"
		}
	    }	    
	}
	# d--------------------------------------------------------------------------------
	"parse" {
	    switch [llength $aCom] {
		2 {
		    switch -- [lindex $aCom 1] {
			0 {
			    set CParse 0
			    printf "Parse: $CParse"			    
			}
			1 {
			    set CParse 1
			    printf "Parse: $CParse"			    
			}
			default {
			    printf "Parse: wrong args!"
			}
		    }
		}
		1 {
		    set CParse [expr !$CParse]
		    printf "Parse: $CParse"
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'parse'!"
		}
	    }
	}
	# d--------------------------------------------------------------------------------
	"showme" {
	    switch [llength $aCom] {
		2 {
		    printf [lindex $aCom 1]
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'showme'!"
		}
	    }	    
	}
	# d--------------------------------------------------------------------------------
	"evalfile" {
	    switch [llength $aCom] {
		2 {
		    set filename [lindex $aCom 1]
		    evalfile $filename
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'evalfile'!"
		}
	    }	    
	}
	"evalsysfile" {
	    switch [llength $aCom] {
		2 {
		    set filename [$CFilM getSysScriptFile [lindex $aCom 1]]
		    evalfile $filename
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'evalfile'!"
		}
	    }	    
	}
	"evaluserfile" {
	    switch [llength $aCom] {
		2 {
		    set filename [$CFilM getScriptFile [lindex $aCom 1]]
		    evalfile $filename
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'evalfile'!"
		}
	    }	    
	}
	"sendfile" {
	    switch [llength $aCom] {
		2 {
		    set filename [lindex $aCom 1]
		    set fileId [open $filename r]
		    if {[catch {puts $CSocket [read $fileId]}]} {
			printf "No session!"
		    }
		    close $fileId
		    printf "File sent: $filename"

		}
		default {
		    bell
		    printf "Wrong number of arguments to 'evalfile'!"
		}
	    }	    	    
	}
	# d--------------------------------------------------------------------------------
	"nop" {}
	# d--------------------------------------------------------------------------------
	"sleep" { after [expr [lindex $aCom 1]*1000] }
	# d--------------------------------------------------------------------------------
	"bell" {
	    switch [llength $aCom] {
		1 {
		    bell
		}
		2 {
		    switch -exact -- [lindex $aCom 1] {
			on    { exec xset b on }
			off   { exec xset b off }
			reset { exec xset b }
			default { printf "Wrong arguments to 'bell'!" }			
		    }
		}
		4 {
		    exec xset b [lindex $aCom 1] [lindex $aCom 2] [lindex $aCom 3] 
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'bell'!"
		}
	    }	    
	}
	# d--------------------------------------------------------------------------------
	"command" {
	    switch [llength $aCom] {
		2 {
		    $CComM add [lindex $aCom 1]
		}
		1 {
		    set i 0
		    foreach com [$CComM getAllNames] {
			printf "Command $i: $com"
			incr i
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'command'!"
		}
	    }	    
	}
	"uncommand" {
	    switch [llength $aCom] {
		2 {
		    $CComM rem [lindex $aCom 1]
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'uncommand'!"
		}
	    }	    
	}
	# d--------------------------------------------------------------------------------
	"tab" {
	    switch [llength $aCom] {
		2 {
		    $CTabM add [lindex $aCom 1]
		}
		1 {
		    set i 0
		    printf "Tabs: [lsort [$CTabM getAllNames]]"
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'tab'!"
		}
	    }	    
	}
	"untab" {
	    switch [llength $aCom] {
		2 {
		    $CTabM rem [lindex $aCom 1]
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'untab'!"
		}
	    }	    
	}

	# d--------------------------------------------------------------------------------
	"notouch" {
	    set level   [lindex $aCom 1]
	    set pattern [lindex $aCom 2]
	    if {![regexp -- {^[0-9]$} $level]} {
		printf "Notouch: wrong level!"
		return
	    }
	    switch [llength $aCom] {
		3 {
		    $CNotM($level) add $pattern ""
		    printf "Notouch: $pattern."
		}
		2 {
		    if {[$CNotM($level) isEmpty]} {
			printf "No notouches defined!"
		    } else { 
			foreach name [$CNotM($level) getAllNames] {
			    printf "Notouch: $name:\t [$CNotM($level) getValue $name]"
			}
		    }
		}
		1 {
		    for {set level 0} {$level<10} {incr level} {
			printf "Notouches of level $level:"
			if {[$CNotM($level) isEmpty]} {
			    printf "No notouches defined!"
			} else { 
			    foreach name [$CNotM($level) getAllNames] {
				printf "Notouch: $name:\t [$CNotM($level) getValue $name]"
			    }
			}
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'notouch'!"
		}
	    }
	}
	"unnotouch" {
	    set level   [lindex $aCom 1]
	    set pattern [lindex $aCom 2]
	    if {![regexp -- {^[0-9]$} $level]} {
		printf "Notouch: wrong level!"
		return
	    }
	    switch [llength $aCom] {
		3 {
		    if {[$CNotM($level) isMatching $pattern]} {
			printf "No notouches, that matches pattern: $pattern!"
		    } else { 
			foreach name [$CNotM($level) getAllMatching "$pattern"] {
			    $CNotM($level) rem $name
			    printf "Notouch: '$name' removed!"
			}
		    }		    
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'unnotouch'!"
		}
	    }	    
	}
	# d--------------------------------------------------------------------------------
	"substitute" {
	    set level   [lindex $aCom 1]
	    set pattern [lindex $aCom 2]
	    set subst   [lindex $aCom 3]
	    if {![regexp -- {^[0-9]$} $level]} {
		printf "Substitute: wrong level!"
		return
	    }
	    switch [llength $aCom] {
		4 {
		    $CSubM($level) add $pattern $subst
		    printf "Substitute: $pattern:\t $subst"
		}
		3 {
		    if {[$CSubM($level) isMatching $pattern]} {
			printf "No substitution, that matches pattern: $pattern!"
		    } else { 
			foreach name [$CSubM($level) getAllMatching "$pattern"] {
			    printf "Substitute: $name:\t [$CSubM($level) getValue $name]"
			}
		    }
		}
		2 {
		    if {[$CSubM($level) isEmpty]} {
			printf "No substitutions defined!"
		    } else { 
			foreach name [$CSubM($level) getAllNames] {
			    printf "Substitute: $name:\t [$CSubM($level) getValue $name]"
			}
		    }
		}
		1 {
		    for {set level 0} {$level<10} {incr level} {
			printf "Substitutions of level $level:"
			if {[$CSubM($level) isEmpty]} {
			    printf "No substitutions defined!"
			} else { 
			    foreach name [$CSubM($level) getAllNames] {
				printf "Substitute: $name:\t [$CSubM($level) getValue $name]"
			    }
			}
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'substitute'!"
		}
	    }
	}
	"unsubstitute" {
	    set level   [lindex $aCom 1]
	    set pattern [lindex $aCom 2]
	    if {![regexp -- {^[0-9]$} $level]} {
		printf "Substitute: wrong level!"
		return
	    }
	    switch [llength $aCom] {
		3 {
		    if {[$CSubM($level) isMatching $pattern]} {
			printf "No substitution, that matches pattern: $pattern!"
		    } else { 
			foreach name [$CSubM($level) getAllMatching "$pattern"] {
			    $CSubM($level) rem $name
			    printf "Substitute: '$name' removed!"
			}
		    }		    
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'unsubstitute'!"
		}
	    }	    
	}
	# d--------------------------------------------------------------------------------
	"highlight" {
	    set level   [lindex $aCom 1]
	    set pattern [lindex $aCom 2]
	    set hl      [lindex $aCom 3]
	    if {![regexp -- {^[0-9]$} $level]} {
		printf "Highlight: wrong level!"
		return
	    }
	    switch [llength $aCom] {
		4 {
		    $CHilM($level) add $pattern $hl
		    printf "Highlight: $pattern:\t $hl"
		}
		3 {
		    if {[$CHilM($level) isMatching $pattern]} {
			printf "No highlight, that matches pattern: $pattern!"
		    } else { 
			foreach name [$CHilM($level) getAllMatching "$pattern"] {
			    printf "Highlight: $name:\t [$CHilM($level) getValue $name]"
			}
		    }
		}
		2 {
		    if {[$CHilM($level) isEmpty]} {
			printf "No highlights defined!"
		    } else { 
			foreach name [$CHilM($level) getAllNames] {
			    printf "Highlight: $name:\t [$CHilM($level) getValue $name]"
			}
		    }
		}
		1 {
		    for {set level 0} {$level<10} {incr level} {
			printf "Highlightnings of level $level:"
			if {[$CHilM($level) isEmpty]} {
			    printf "No highlights defined!"
			} else { 
			    foreach name [$CHilM($level) getAllNames] {
				printf "Highlight: $name:\t [$CHilM($level) getValue $name]"
			    }
			}
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'highlight'!"
		}
	    }
	}
	"unhighlight" {
	    set level   [lindex $aCom 1]
	    set pattern [lindex $aCom 2]
	    if {![regexp -- {^[0-9]$} $level]} {
		printf "Highlight: wrong level!"
		return
	    }
	    switch [llength $aCom] {
		3 {
		    if {[$CHilM($level) isMatching $pattern]} {
			printf "No highlight, that matches pattern: $pattern!"
		    } else { 
			foreach name [$CHilM($level) getAllMatching "$pattern"] {
			    $CHilM($level) rem $name
			    printf "Highlight: '$name' removed!"
			}
		    }		    
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'unhilight'!"
		}
	    }	    
	}
	# d--------------------------------------------------------------------------------
	"action" {
	    set level   [lindex $aCom 1]
	    set pattern [lindex $aCom 2]
	    set action  [lindex $aCom 3]
	    if {![regexp -- {^[0-9]$} $level]} {
		printf "Action: wrong level!"
		return
	    }
	    switch [llength $aCom] {
		4 {
		    $CActM($level) add $pattern $action
		    printf "Action: $pattern:\t $action"
		}
		3 {
		    if {[$CActM($level) isMatching $pattern]} {
			printf "No action, that matches pattern: $pattern!"
		    } else { 
			foreach name [$CActM($level) getAllMatching "$pattern"] {
			    printf "Action: $name:\t [$CActM($level) getValue $name]"
			}
		    }
		}
		2 {
		    if {[$CActM($level) isEmpty]} {
			printf "No actions defined!"
		    } else { 
			foreach name [$CActM($level) getAllNames] {
			    printf "Action: $name:\t [$CActM($level) getValue $name]"
			}
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'action'!"
		}
	    }
	}
	"unaction" {
	    set level   [lindex $aCom 1]
	    set pattern [lindex $aCom 2]
	    if {![regexp -- {^[0-9]$} $level]} {
		printf "Action: wrong level!"
		return
	    }
	    switch [llength $aCom] {
		3 {
		    if {[$CActM($level) isMatching $pattern]} {
			printf "No action, that matches pattern: $pattern!"
		    } else { 
			foreach name [$CActM($level) getAllMatching "$pattern"] {
			    $CActM($level) rem $name
			    printf "Action: '$name' removed!"
			}
		    }		    
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'unaction'!"
		}
	    }	    
	}
	# d--------------------------------------------------------------------------------
	"alias" {
	    switch [llength $aCom] {
		3 {
		    set aliasname  [lindex $aCom 1]
		    set aliasvalue [lindex $aCom 2]
		    $CAliM add $aliasname $aliasvalue
		    printf "Alias: $aliasname:\t [$CAliM getValue $aliasname]"
		}
		2 {
		    set pattern [lindex $aCom 1]
		    if {[$CAliM isMatching $pattern]} {
			printf "No alias, that matches pattern: $pattern!"
		    } else { 
			foreach aliasname [$CAliM getAllMatching "$pattern"] {
			    printf "Alias: $aliasname:\t [$CAliM getValue $aliasname]"
			}
		    }
		}
		1 {
		    if {[$CAliM isEmpty]} {
			printf "No aliases defined!"
		    } else { 
			foreach aliasname [$CAliM getAllNames] {
			    printf "Alias: $aliasname:\t [$CAliM getValue $aliasname]"
			}
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'alias'!"
		}
	    }
	}
	"unalias" {
	    switch [llength $aCom] {
		2 {
		    set pattern [lindex $aCom 1]
		    if {[$CAliM isMatching $pattern]} {
			printf "No alias, that matches pattern: $pattern!"
		    } else { 
			foreach aliasname [$CAliM getAllMatching "$pattern"] {
			    $CAliM rem $aliasname
			    printf "Alias: '$aliasname' removed!"
			}
		    }		    
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'unalias'!"
		}
	    }	    
	}
	# d--------------------------------------------------------------------------------
	"variable" {
	    switch [llength $aCom] {
		3 {
		    set varname  [lindex $aCom 1]
		    set varvalue [lindex $aCom 2]
		    $CVarM add $varname $varvalue
		    printf "Variable: $varname:\t [$CVarM getValue $varname]"
		}
		2 {
		    set pattern [lindex $aCom 1]
		    if {[$CVarM isMatching $pattern]} {
			printf "No variable, that matches pattern: $pattern!"
		    } else { 
			foreach varname [$CVarM getAllMatching "$pattern"] {
			    printf "Variable: $varname:\t [$CVarM getValue $varname]"
			}
		    }
		}
		1 {
		    if {[$CVarM isEmpty]} {
			printf "No variables defined!"
		    } else { 
			foreach varname [$CVarM getAllNames] {
			    printf "Variable: $varname:\t [$CVarM getValue $varname]"
			}
		    }
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'variable'!"
		}
	    }
	}
	"unvariable" {
	    switch [llength $aCom] {
		2 {
		    set pattern [lindex $aCom 1]
		    if {[$CVarM isMatching $pattern]} {
			printf "No variable, that matches pattern: $pattern!"
		    } else { 
			foreach name [$CVarM getAllMatching "$pattern"] {
			    $CVarM rem $name
			    printf "Variable: '$name' removed!"
			}
		    }		    
		}
		default {
		    bell
		    printf "Wrong number of arguments to 'unvariable'!"
		}
	    }	    
	}
	# --------------------------------------------------------------------------------
	default {
	    printf "No such command!"
	}
    }
}



############################################################################
body TEntryX::splitCommand {aCom} {
    set part1       ""	
    set l           [string length $aCom]

    set bl 0 ; #bracket level
    set mode t ;# toplevel
    # q: in quotes
    # b: in brackets

    for {set i 0} {$i<$l} {incr i} {
	set c [string index $aCom $i]
	
	switch $mode {
	    t {
		switch -exact -- $c {
		    \; {
			incr i
			break
		    }
		    \" {
			set mode q
			append part1 $c
		    }
		    \\ {
			incr i
			set cc [string index $aCom $i]
			if {[string compare "\;" $cc]==0} {
			    append part1 $cc
			} else {
			    append part1 $c
			    append part1 $cc
			}
		    }
		    \{ {
			set mode b
			set bl 1
			append part1 $c
		    }
		    default {
			append part1 $c
		    }
		}
	    }
	    b {
		switch -exact -- $c {
		    \{ {
			incr bl
			append part1 $c
		    }
		    \} {
			incr bl -1
			append part1 $c
			if {$bl==0} {
			    set mode t
			}
		    }
		    \\ {
			append part1 \\
			    incr i
			append part1 [string index $aCom $i]
		    }
		    default {
			append part1 $c
		    }
		}
	    }
	    q {
		switch -exact -- $c {
		    \" {
			set mode t
			append part1 $c
		    }
		    \\ {
			append part1 \\
			    incr i
			append part1 [string index $aCom $i]
		    }
		    default {
			append part1 $c
		    }
		}
	    }
	}
    }
    substCommandVars $part1
    if {$i!=$l} {
	set part2 [string range $aCom $i $l]
	splitCommand $part2
    }    
}

############################################################################
body TEntryX::substCommandVars {aCom args} {
    set part1       ""	
    set l           [string length $aCom]

    set bl 0 ; #bracket level
    set mode t ;# toplevel
    # q: in quotes
    # b: in brackets

    for {set i 0} {$i<$l} {incr i} {
	set c [string index $aCom $i]
	
	switch $mode {
	    t {
		switch -exact -- $c {
		    \$ {
			incr i
			set end [string wordend $aCom $i]
			if {[regexp -nocase -- {[^a-z0-9_]} [string index $aCom $end]]} {incr end -1}
			set varname [string range $aCom $i $end]
			if {[regexp -nocase -- {[0-9]} [string index $varname 0]]} {
			    # var belongs to alias 
			    append part1 \$
			    append part1 [string index $aCom $i]
			} else {
			    # stardart var
			    if {[$CVarM exists $varname]} {
				append part1 [$CVarM getValue $varname]
				set i $end
			    } else {
				append part1 \$
				append part1 [string index $aCom $i]
				TInformer $itk_interior.mess -vanishafter 3 -information "A variable named '$varname' doesn't exist!"
			    }
			}
		    }
		    \" {
			set mode q
			append part1 $c
		    }
		    \\ {
			incr i
			set cc [string index $aCom $i]
			if {[string compare "\$" $cc]==0} {
			    append part1 $cc
			} else {
			    append part1 $c
			    append part1 $cc
			}
		    }
		    \{ {
			set mode b
			set bl 1
			append part1 $c
		    }
		    default {
			append part1 $c
		    }
		}
	    }
	    b {
		switch -exact -- $c {
		    \{ {
			incr bl
			append part1 $c
		    }
		    \} {
			incr bl -1
			append part1 $c
			if {$bl==0} {
			    set mode t
			}
		    }
		    \\ {
			append part1 \\
			    incr i
			append part1 [string index $aCom $i]
		    }
		    default {
			append part1 $c
		    }
		}
	    }
	    q {
		switch -exact -- $c {
		    \$ {
			incr i
			set end [string wordend $aCom $i]
			if {[regexp -nocase -- {[^a-z0-9_]} [string index $aCom $end]]} {incr end -1}
			set varname [string range $aCom $i $end]
			if {[regexp -nocase -- {[0-9]} [string index $varname 0]]} {
			    # var belongs to alias 
			    append part1 \$
			    append part1 [string index $aCom $i]
			} else {
			    # stardart var
			    if {[$CVarM exists $varname]} {
				append part1 [$CVarM getValue $varname]
				set i $end
			    } else {
				append part1 \$
				append part1 [string index $aCom $i]
				TInformer $itk_interior.mess -vanishafter 3 \
				    -information "A variable named '$varname' doesn't exist!"
			    }
			}
		    }
		    \" {
			set mode t
			append part1 $c
		    }
		    \\ {
			append part1 \\
			    incr i
			append part1 [string index $aCom $i]
		    }
		    default {
			append part1 $c
		    }
		}
	    }
	}
    }
    if {[llength $args]==0} {
	substCommandAlias $part1
    } else {
	return $part1
    }
}

body TEntryX::tabCompletition {} {
    global _TEntryX

    set currentInput $_TEntryX($this)

    if {$CTabCycle>0} {

	set _TEntryX($this) "$CTabBegString[lindex $CTabComplSubList $CTabPos]$CTabEndString"
	set insc [string length "$CTabBegString[lindex $CTabComplSubList $CTabPos]"]
	$itk_component(com) icursor $insc

	incr CTabPos
	if { $CTabPos == [llength $CTabComplSubList]} {
	    set CTabPos 0
	} 
	
    } else {
	set     tabComplList [$CTabM   getTabs]
	foreach tab [$COutput getTabs] {
	    lappend tabComplList $tab
	}

	set  actCurPos [$itk_component(com) index insert]
	incr actCurPos -1

	set  i1 [string wordstart $currentInput $actCurPos] 
	set  i2 [expr [string wordend   $currentInput $actCurPos]-1]
	set  i3 [expr [string wordstart $currentInput [string length $currentInput]] -1]
	
	set tabPattern    [string range $currentInput $i1          $i2]
	set CTabBegString [string range $currentInput 0            [expr $i1-1]]
	set CTabEndString [string range $currentInput [expr $i2+1] $i3]

	if {[string compare " " "$tabPattern"] == 0} {
	    set    tabPattern ""
	    append CTabBegString " "
	}
	if {[string compare "\t" "$tabPattern"] == 0} {
	    set    tabPattern ""
	    append CTabBegString "\t"
	}
	
	set CTabComplSubList ""	
	foreach compl $tabComplList {
	    if {[string match "$tabPattern\*" "$compl"]} {
		lappend CTabComplSubList $compl
	    }
	}
	set CTabComplSubList [lsort -ascii -increasing $CTabComplSubList]

	# remove double entries
	for {set i 1} {$i<[llength $CTabComplSubList]} {incr i} {
	    set j [expr $i-1]
	    if {[string match [lindex $CTabComplSubList $i] [lindex $CTabComplSubList $j]]} {
		set CTabComplSubList [lreplace $CTabComplSubList $i $i]
		incr i -1
	    }
	}

	switch -- [llength $CTabComplSubList] {
	    0 {
		printf "No tab-completition possible!"
		return
	    } 
	    1 {
		set _TEntryX($this) "$CTabBegString[lindex $CTabComplSubList 0]$CTabEndString"	
		set insc [string length "$CTabBegString[lindex $CTabComplSubList 0]"]
		$itk_component(com) icursor $insc
	    }
	    default {
		set sub  [lindex $CTabComplSubList 0]
		set subl [expr [string length $sub] -1]
	
		foreach compl $CTabComplSubList {
		    while {![string match "$sub\*" $compl]} {
			incr subl -1
			set  sub  [string range "$sub" 0 $subl]
		    }
		}

		set _TEntryX($this) "$CTabBegString$sub$CTabEndString"
		printf "tab-completitions: $CTabComplSubList"
		
		set insc [string length "$CTabBegString$sub"]
		$itk_component(com) icursor $insc
	    }
	}
	
	set CTabCycle 1
	set CTabPos   0
    }
}

proc bracketLevel {aCom} {
    set l           [string length $aCom]
    set bl 0 ; #bracket level
    set mode t ;# toplevel
    # q: in quotes
    # b: in brackets

    for {set i 0} {$i<$l} {incr i} {
	set c [string index $aCom $i]
	
	switch $mode {
	    t {
		switch -exact -- $c {
		    \" {
			set mode q
		    }
		    \\ {
			incr i
		    }
		    \{ {
			set mode b
			set bl 1
		    }
		    \} {
			return -1
		    }
		}
	    }
	    b {
		switch -exact -- $c {
		    \{ {
			incr bl
		    }
		    \} {
			incr bl -1
			if {$bl==0} {
			    set mode t
			}
		    }
		    \\ {
			incr i
		    }
		}
	    }
	    q {
		switch -exact -- $c {
		    \" {
			set mode t
			append part1 $c
		    }
		    \\ {
			incr i
		    }
		}
	    }
	}
    }

    if {![string compare $mode "q"]} {
	return -2
    }
    return $bl
    
}




############################################################################
############################################################################
############################################################################




