class TESCParser {
    # leading 'esc' must be stripped already!
    variable CESCIntermediates
    variable CESCParameters
    variable CESCFinal
    variable CESCDummy
    variable CESCParsedText    

    constructor {} {
	set CESCIntermediates  ""
	set CESCParameters     ""
	set CESCFinal          ""
	set CESCDummy          ""
	set CESCParsedText     ""
    }    
    method escAnalyse {aStr} {
	if {[ regexp -- {^\[([0-?]*)([ -/]*)([@-~])(.*)} \
		  $aStr CESCDummy CESCParameters CESCIntermediates CESCFinal CESCParsedText]} {
	    return 1
	}
	if {[ regexp -- {^([ -/]*)([0-~])(.*)} \
		 $aStr CESCDummy CESCIntermediates CESCFinal CESCParsedText]} {
	    set CESCParameters     ""
	    return 1
	}
	set CESCIntermediates  ""
	set CESCParameters     ""
	set CESCFinal          ""
	set CESCParsedText     $aStr
	return 0
    }
    method escCode {}       { return $CESCFinal }
    method escRestOfText {} { return $CESCParsedText}
    method escArg {}        { return $CESCParameters }

}


